#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_ChatCFG.h"
std::auto_ptr<Fish_ChatCFG> Fish_ChatCFG::msSingleton(nullptr);

int Fish_ChatCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_ChatCFGData* Fish_ChatCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_ChatCFGData>& Fish_ChatCFG::GetMapData()
{
	return mMapData;
}

void Fish_ChatCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_ChatCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_ChatCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mChatInfo = element->Attribute("ChatInfo");
		data.mDuration = element->FloatAttribute("Duration");
		data.mSoundID = element->IntAttribute("SoundID");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_ChatCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_ChatCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_ChatCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_ChatCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_ChatCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "ChatInfo", data.mChatInfo);
		LuaCfgHelper::readFloat(L, "Duration", data.mDuration);
		LuaCfgHelper::readInt(L, "SoundID", data.mSoundID);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_ChatCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_ChatCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_ChatCFG* Fish_ChatCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_ChatCFG());
	}
	return msSingleton.get();
}

void Fish_ChatCFG::Release()
{
	msSingleton.reset(nullptr);
}
